import re
file_with_paths = raw_input("Enter the file path containing list of custom files\n")
extra_patterns = raw_input("Enter files with extra patterns(if any) you wish to add, hit enter if you dont wish to add any patterns\n")
output_path = raw_input("Enter the path to generate the output file\n")

list_files_moved = ['large-loading.gif','home.svg','lgt.svg','my_stuff.svg','open_authorization.svg','open_orders.svg','profile.svg','switchto.svg','Help.svg','default-service-icon.svg',
					'search_normal.svg','sprite_icons.png','glyphicons-halflings.png','glyphicons-halflings-white.png','sprite_main.png','homeslider_bg_block1.png','homeslider_bg_block2.png',
					'homeslider_bg_block3.png','homeslider_bg_active.png','page_heading_bg.png','add.svg','close_delete.svg','search_hover.svg','search_press.svg','notification.svg',
					'carousel_normal_right.svg','carousel_hover_right.svg','carousel_press_right.svg','carousel_normal_left.svg','carousel_hover_left.svg','carousel_press_left.svg',
					'help_normal.svg','help_hover.svg','alertCritical.svg','mystuff-icons-sm.png','mystuff-icons.png','search_OverDarkBackground.svg','deselectbox_arrow.png','selectbox_arrow.png',
					'singstar.png','page_heading_bg.png','windows-icon.png','linux-icon.png','info_normal.svg','info_hover.svg','custom.css','ngc']
dict_patterns = {
				'large-loading.gif': re.compile("/modules/ngc/img/large-loading.gif"),
				'home.svg': re.compile("/modules/ngc/img/home.svg"),
				'lgt.svg': re.compile("/modules/ngc/img/lgt.svg"),
				'my_stuff.svg': re.compile("/modules/ngc/img/my_stuff.svg"),
				'open_authorization.svg': re.compile("/modules/ngc/img/open_authorization.svg"),
				'open_orders.svg': re.compile("/modules/ngc/img/open_orders.svg"),
				'profile.svg': re.compile("/modules/ngc/img/profile.svg"),
				'switchto.svg': re.compile("/modules/ngc/img/switchto.svg"),
				'Help.svg': re.compile("/modules/ngc/img/Help.svg"),
				'default-service-icon.svg': re.compile("/modules/ngc/img/default-service-icon.svg"),
				'search_normal.svg': re.compile("/modules/ngc/img/search_normal.svg"),
				'sprite_icons.png': re.compile("/modules/ngc/img/sprite_icons.png"),
				'glyphicons-halflings.png': re.compile("/modules/ngc/img/glyphicons-halflings.png"),
				'glyphicons-halflings-white.png': re.compile("/modules/ngc/img/glyphicons-halflings-white.png"),
				'sprite_main.png': re.compile("/modules/ngc/img/sprite_main.png"),
				'homeslider_bg_block1.png': re.compile("/modules/ngc/img/homeslider_bg_block1.png"),
				'homeslider_bg_block2.png': re.compile("/modules/ngc/img/homeslider_bg_block2.png"),
				'homeslider_bg_block3.png': re.compile("/modules/ngc/img/homeslider_bg_block3.png"),
				'homeslider_bg_active.png': re.compile("/modules/ngc/img/homeslider_bg_active.png"),
				'page_heading_bg.png': re.compile("/modules/ngc/img/page_heading_bg.png"),
				'add.svg': re.compile("/modules/ngc/img/add.svg"),
				'close_delete.svg': re.compile("/modules/ngc/img/close_delete.svg"),
				'search_hover.svg': re.compile("/modules/ngc/img/search_hover.svg"),
				'search_press.svg': re.compile("/modules/ngc/img/search_press.svg"),
				'notification.svg': re.compile("/modules/ngc/img/notification.svg"),
				'carousel_normal_right.svg': re.compile("/modules/ngc/img/carousel_normal_right.svg"),
				'carousel_hover_right.svg': re.compile("/modules/ngc/img/carousel_hover_right.svg"),
				'carousel_press_right.svg': re.compile("/modules/ngc/img/carousel_press_right.svg"),
				'carousel_normal_left.svg': re.compile("/modules/ngc/img/carousel_normal_left.svg"),
				'carousel_hover_left.svg': re.compile("/modules/ngc/img/carousel_hover_left.svg"),
				'carousel_press_left.svg': re.compile("/modules/ngc/img/carousel_press_left.svg"),
				'help_normal.svg': re.compile("/modules/ngc/img/help_normal.svg"),
				'help_hover.svg': re.compile("/modules/ngc/img/help_hover.svg"),
				'alertCritical.svg': re.compile("/modules/ngc/img/alertCritical.svg"),
				'mystuff-icons-sm.png': re.compile("/modules/ngc/img/mystuff-icons-sm.png"),
				'mystuff-icons.png': re.compile("/modules/ngc/img/mystuff-icons.png"),
				'search_OverDarkBackground.svg': re.compile("/modules/ngc/img/search_OverDarkBackground.svg"),
				'deselectbox_arrow.png': re.compile("/modules/ngc/img/deselectbox_arrow.png"),
				'selectbox_arrow.png': re.compile("/modules/ngc/img/selectbox_arrow.png"),
				'singstar.png': re.compile("/modules/ngc/img/singstar.png"),
				'page_heading_bg.png': re.compile("/modules/ngc/img/page_heading_bg.png"),
				'windows-icon.png': re.compile("/modules/ngc/img/windows-icon.png"),
				'linux-icon.png': re.compile("/modules/ngc/img/linux-icon.png"),
				'info_normal.svg': re.compile("/modules/ngc/img/info_normal.svg"),
				'info_hover.svg': re.compile("/modules/ngc/img/info_hover.svg"),
				'custom.css': re.compile("/modules/ngc/extensions/classic/custom.css"),

				'ngc': re.compile("/modules/ngc[)\'\"/]")
				}
dict_replacements = {
					'large-loading.gif': "/website/ServiceCatalogWebsite/common/images/large-loading.gif",
					'home.svg': "/website/ServiceCatalogWebsite/common/images/home.svg",
					'lgt.svg': "/website/ServiceCatalogWebsite/common/images/lgt.svg",
					'my_stuff.svg': "/website/ServiceCatalogWebsite/common/images/my_stuff.svg",
					'open_authorization.svg': "/website/ServiceCatalogWebsite/common/images/open_authorization.svg",
					'open_orders.svg': "/website/ServiceCatalogWebsite/common/images/open_orders.svg",
					'profile.svg': "/website/ServiceCatalogWebsite/common/images/profile.svg",
					'switchto.svg': "/website/ServiceCatalogWebsite/common/images/switchto.svg",
					'Help.svg': "/website/ServiceCatalogWebsite/common/images/Help.svg",
					'default-service-icon.svg': "/website/ServiceCatalogWebsite/common/images/default-service-icon.svg",
					'search_normal.svg': "/website/ServiceCatalogWebsite/common/images/search_normal.svg",
					'sprite_icons.png': "/website/ServiceCatalogWebsite/common/images/sprite_icons.png",
					'glyphicons-halflings.png': "/website/ServiceCatalogWebsite/common/images/glyphicons-halflings.png",
					'glyphicons-halflings-white.png': "/website/ServiceCatalogWebsite/common/images/glyphicons-halflings-white.png",
					'sprite_main.png': "/website/ServiceCatalogWebsite/common/images/sprite_main.png",
					'homeslider_bg_block1.png': "/website/ServiceCatalogWebsite/common/images/homeslider_bg_block1.png",
					'homeslider_bg_block2.png': "/website/ServiceCatalogWebsite/common/images/homeslider_bg_block2.png",
					'homeslider_bg_block3.png': "/website/ServiceCatalogWebsite/common/images/homeslider_bg_block3.png",
					'homeslider_bg_active.png': "/website/ServiceCatalogWebsite/common/images/homeslider_bg_active.png",
					'page_heading_bg.png': "/website/ServiceCatalogWebsite/common/images/page_heading_bg.png",
					'add.svg': "/website/ServiceCatalogWebsite/common/images/add.svg",
					'close_delete.svg': "/website/ServiceCatalogWebsite/common/images/close_delete.svg",
					'search_hover.svg': "/website/ServiceCatalogWebsite/common/images/search_hover.svg",
					'search_press.svg': "/website/ServiceCatalogWebsite/common/images/search_press.svg",
					'notification.svg': "/website/ServiceCatalogWebsite/common/images/notification.svg",
					'carousel_normal_right.svg': "/website/ServiceCatalogWebsite/common/images/carousel_normal_right.svg",
					'carousel_hover_right.svg': "/website/ServiceCatalogWebsite/common/images/carousel_hover_right.svg",
					'carousel_press_right.svg': "/website/ServiceCatalogWebsite/common/images/carousel_press_right.svg",
					'carousel_normal_left.svg': "/website/ServiceCatalogWebsite/common/images/carousel_normal_left.svg",
					'carousel_hover_left.svg': "/website/ServiceCatalogWebsite/common/images/carousel_hover_left.svg",
					'carousel_press_left.svg': "/website/ServiceCatalogWebsite/common/images/carousel_press_left.svg",
					'help_normal.svg': "/website/ServiceCatalogWebsite/common/images/help_normal.svg",
					'help_hover.svg': "/website/ServiceCatalogWebsite/common/images/help_hover.svg",
					'alertCritical.svg': "/website/ServiceCatalogWebsite/common/images/alertCritical.svg",
					'mystuff-icons-sm.png': "/website/ServiceCatalogWebsite/common/images/mystuff-icons-sm.png",
					'mystuff-icons.png': "/website/ServiceCatalogWebsite/common/images/mystuff-icons.png",
					'search_OverDarkBackground.svg': "/website/ServiceCatalogWebsite/common/images/search_OverDarkBackground.svg",
					'deselectbox_arrow.png': "/website/ServiceCatalogWebsite/common/images/deselectbox_arrow.png",
					'selectbox_arrow.png': "/website/ServiceCatalogWebsite/common/images/selectbox_arrow.png",
					'singstar.png': "/website/ServiceCatalogWebsite/common/images/singstar.png",
					'page_heading_bg.png': "/website/ServiceCatalogWebsite/common/images/page_heading_bg.png",
					'windows-icon.png': "/website/ServiceCatalogWebsite/common/images/windows-icon.png",
					'linux-icon.png': "/website/ServiceCatalogWebsite/common/images/linux-icon.png",
					'info_normal.svg': "/website/ServiceCatalogWebsite/common/images/info_normal.svg",
					'info_hover.svg': "/website/ServiceCatalogWebsite/common/images/info_hover.svg",
					'info_hover.svg': "/website/ServiceCatalogWebsite/common/images/info_hover.svg",
					'custom.css': "/website/ServiceCatalogWebsite/common/css/custom.css",
					'ngc': "/website/ServiceCatalogWebsite/application" 
					}

try:
	if extra_patterns.strip()!='':
		extra_pattern_index = 0
		for pattern in open(extra_patterns,'r').readlines():
			key = 'custom-'+str(extra_pattern_index)
			list_files_moved.append(key)
			dict_patterns[key] = re.compile(pattern.strip())
			dict_replacements[key] = "replace_this"
			extra_pattern_index += 1

	output_file = open(output_path+'/out.csv','w+')
	output_file.write("File moved,String Matched,Refered in file,Line numbers,Current Reference,Suggested reference\n")
	for file_path in open(file_with_paths,'r').readlines():
		regexs_matched = []
		line_numbers = {}
		current_references = {}
		suggested_references = {}
		files_moved = {}
		print file_path.split('/')[-1]
		line_number = 0
		for line in open(file_path.strip('\n'),'r').readlines():
			line = line.strip()
			line_number += 1
			file_moved_index = 0
			for file_moved in list_files_moved:
				found = False
				x  = re.finditer(dict_patterns.get(file_moved),line)
				for match in x:
					found = True
					s = match.start()
					e = match.end()
					suggestion = ""
					if(file_moved != 'ngc'):
						suggestion = line.replace(line[s:e],dict_replacements.get(file_moved))
					else:
						suggestion = line.replace(line[s:e-1],dict_replacements.get(file_moved))
					regex_matched = line[s:e]
					if regex_matched in regexs_matched:
						if type(line_numbers[regex_matched]) is list:
							line_numbers[regex_matched].append(str(line_number))
							current_references[regex_matched].append(line)
							suggested_references[regex_matched].append(suggestion)
						else:
							line_numbers[regex_matched] = [line_numbers[regex_matched], str(line_number)]
							current_references[regex_matched] = [current_references[regex_matched], line]
							suggested_references[regex_matched] = [suggested_references[regex_matched], suggestion]
					else:
						regexs_matched.append(regex_matched)
						line_numbers[regex_matched] = str(line_number)
						current_references[regex_matched] = line 
						suggested_references[regex_matched] = suggestion 
						files_moved[regex_matched] = file_moved
				file_moved_index += 1
				if found:
					break

		for regex_matched in regexs_matched:
			if type(line_numbers[regex_matched]) is list:
				output_string = files_moved[regex_matched]+','+regex_matched+','+file_path.strip()+','+line_numbers[regex_matched][0]+','+current_references[regex_matched][0]+','+suggested_references[regex_matched][0]+'\n'
				length = len(line_numbers[regex_matched])
				for i in range(1,length):
					output_string += ',,,'+line_numbers[regex_matched][i]+','+current_references[regex_matched][i]+','+suggested_references[regex_matched][i]+'\n'
				output_file.write(output_string)
			else:
				output_file.write(files_moved[regex_matched]+','+regex_matched+','+file_path.strip()+','+line_numbers[regex_matched]+','+current_references[regex_matched]+','+suggested_references[regex_matched]+'\n')
	output_file.close()

except IOError as err:
	print err

